import time, threading, pandas, numpy

from api.kraken import Kraken
from api.fake import Fake

def percent_difference(first, second):
    return abs(first-second)/((first+second)/2)

if __name__ == "__main__":
    currency_buy = "XXBT"
    currency_sell = "ZUSD"
    currency_pair = "XXBTZUSD"

    k = Kraken()
    print("1")

    time.sleep(1)

    k.get_ohlc_prices(currency_pair)
    print("3")

    time.sleep(1)

    while True:
        #print("Main loop")
        
        k.get_current_price(currency_pair)
        k.calculate_ema()

        # If we have crypto, check for sell behaviour, if we have fiat, check for buy behavior, otherwise, get really confused
        if k.balances["vol"][currency_buy] > 10**-5:
            # Sell shit
            # If short term change dips below long term change, sell
            if k.short_ema.tail(1)[0][0] < k.long_ema.tail(1)[0][0] and percent_difference(k.short_ema.tail(1)[0][0], k.long_ema.tail(1)[0][0]) > 0.001:
                print("Selling shit")
                k.sell_order(currency_pair, currency_buy, currency_sell, k.balances["vol"][currency_buy])
                print(k.balances)

        elif k.balances["vol"][currency_sell] > 10**-2:
            # Buy shit
            # If short term goes above long term, buy
            if k.short_ema.tail(1)[0][0] > k.long_ema.tail(1)[0][0] and percent_difference(k.short_ema.tail(1)[0][0], k.long_ema.tail(1)[0][0]) > 0.001:
                print("Buying shit")
                k.buy_order(currency_pair, currency_buy, currency_sell, k.balances["vol"][currency_sell] * 0.95 * (1/k.prices.tail(1)[0][0]))
                print(k.balances)

        else:
            raise Exception("There is no currency in this account.")

        time.sleep(3)
